#pragma once

#include "widget.h"
#include <functional>
#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>

class Button : public Widget
{
public:
    explicit Button(const std::string& text);

    virtual void input(const sf::Event& event) override = 0;
    virtual void update() override final;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override final;
    virtual void setRect(const sf::FloatRect& rect) override final;
    virtual void setPosition(const sf::Vector2f& position) override final;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override final;

    virtual void setFillColor(sf::Color&& color);
    virtual void setText(const std::string& text);

protected:
    sf::RectangleShape _button_content;
    sf::Text _button_text;
};

