#pragma once

#include "widget.h"
#include "button.h"
#include <SFML/Graphics/RectangleShape.hpp>

class MenuDrop : public Widget
{
public:
    explicit MenuDrop();

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void setRect(const sf::FloatRect& rect) override;
    virtual void setPosition(const sf::Vector2f& position) override;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const override;

    void addButton(const std::shared_ptr<Button>& button);
    void addSeparator();

    void lock();
    void unlock();
    bool isLocked() const;

private:
    sf::RectangleShape _content_rect;
    bool _is_locked;

    std::size_t _button_height;
    std::size_t _button_index;

    void add(const std::shared_ptr<Widget>& widget);
};
